commit 6f61195e0433f907e5aa1a16f02d4106503d3351
Author: Jakub Jelinek <jakub@redhat.com>
Date:   Tue Sep 14 16:55:04 2021

    c++: Fix __is_*constructible/assignable for templates [PR102305]
    
    is_xible_helper returns error_mark_node (i.e. false from the traits)
    for abstract classes by testing ABSTRACT_CLASS_TYPE_P (to) early.
    Unfortunately, as the testcase shows, that doesn't work on class templates
    that haven't been instantiated yet, ABSTRACT_CLASS_TYPE_P for them is false
    until it is instantiated, which is done when the routine later constructs
    a dummy object with that type.
    
    The following patch fixes this by calling complete_type first, so that
    ABSTRACT_CLASS_TYPE_P test will work properly, while keeping the handling
    of arrays with unknown bounds, or incomplete types where it is done
    currently.
    
    2021-09-14  Jakub Jelinek  <jakub@redhat.com>
    
            PR c++/102305
            * method.c (is_xible_helper): Call complete_type on to.
    
            * g++.dg/cpp0x/pr102305.C: New test.
    
    (cherry picked from commit f008fd3a480e3718436156697ebe7eeb47841457)

diff --git a/gcc/cp/method.c b/gcc/cp/method.c
index 1c3cf834bf4..b82aeefa6ab 100644
--- a/gcc/cp/method.c
+++ b/gcc/cp/method.c
@@ -2079,6 +2079,7 @@ constructible_expr (tree to, tree from)
 static tree
 is_xible_helper (enum tree_code code, tree to, tree from, bool trivial)
 {
+  to = complete_type (to);
   deferring_access_check_sentinel acs (dk_no_deferred);
   if (VOID_TYPE_P (to) || ABSTRACT_CLASS_TYPE_P (to)
       || (from && FUNC_OR_METHOD_TYPE_P (from)
diff --git a/gcc/testsuite/g++.dg/cpp0x/pr102305.C b/gcc/testsuite/g++.dg/cpp0x/pr102305.C
new file mode 100644
index 00000000000..e63adcf5364
--- /dev/null
+++ b/gcc/testsuite/g++.dg/cpp0x/pr102305.C
@@ -0,0 +1,39 @@
+// PR c++/102305
+// { dg-do compile { target c++11 } }
+
+namespace std
+{
+  template<typename _Tp, _Tp __v>
+    struct integral_constant
+    {
+      static constexpr _Tp value = __v;
+      typedef integral_constant<_Tp, __v> type;
+    };
+
+  template<typename _Tp, _Tp __v>
+    constexpr _Tp integral_constant<_Tp, __v>::value;
+
+  typedef integral_constant<bool, true> true_type;
+  typedef integral_constant<bool, false> false_type;
+
+  template<bool __v>
+    using bool_constant = integral_constant<bool, __v>;
+
+  template<typename _Tp, typename... _Args>
+    struct is_constructible
+    : public bool_constant<__is_constructible(_Tp, _Args...)>
+    {
+    };
+}
+
+template<typename>
+struct A {
+  virtual ~A() = 0;
+};
+
+struct B {
+  virtual ~B() = 0;
+};
+
+static_assert(!std::is_constructible<A<int> >::value, "");
+static_assert(!std::is_constructible<B>::value, "");

